# gcp::ReactionStep Class Reference

the list of reactants before or after a reaction arrow. More...

`#include <gcp/reaction-step.h>`

Inheritance diagram for gcp::ReactionStep:

List of all members.

## Public Member Functions

| ReactionStep ()
virtual | ~ReactionStep ()
| ReactionStep (Reaction *reaction, std::map< double, gcu::Object * > &Children, std::map< gcu::Object *, ArtDRect > Objects)
void | Add (GtkWidget *w) const
xmlNodePtr | Save (xmlDocPtr xml) const
bool | Load (xmlNodePtr node)
double | GetYAlign ()
bool | OnSignal (gcu::SignalId Signal, gcu::Object *Child)
void | AddArrow (ReactionArrow *arrow)
void | RemoveArrow (ReactionArrow *arrow)

## Detailed Description

the list of reactants before or after a reaction arrow.

The ReactionStep class is a group class which owns a list of reactants and the operators betwwen them. This class is misnamed, since the step is more generally associated with the arrow. It might be renamed ReactionStage in the future if it is possible without making old files unreadable.

Definition at line 48 of file reaction-step.h.

## Constructor & Destructor Documentation

gcp::ReactionStep::ReactionStep | ( |  | ) |

The default constructor.

virtual gcp::ReactionStep::~ReactionStep | ( |  | ) | `[virtual]`

The destructor.

gcp::ReactionStep::ReactionStep | ( | Reaction * | reaction,
|  | std::map< double, gcu::Object * > & | Children,
|  | std::map< gcu::Object *, ArtDRect > | Objects |
| ) |  |  |

Parameters:

  | reaction | the parent reaction.
  | Children | the reactants from which to build the new instance.
  | Objects | the rectangles bounding the reactants.

Buils a new reaction step from the children and adds as many eaction operators as necessary. All children will be horizontally aligned.

## Member Function Documentation

void gcp::ReactionStep::Add | ( | GtkWidget * | w | ) | const`[virtual]`

Parameters:

  | w | the GtkWidget inside which the step will be displayed.

Calledto add a representation of the step in the widget. This is done for all objects but in the case of reaction steps, it does nothing. Just there to override the default.

Reimplemented from gcu::Object.

xmlNodePtr gcp::ReactionStep::Save | ( | xmlDocPtr | xml | ) | const`[virtual]`

Parameters:

  | xml | the xmlDoc used to save the document.

Used to save the reaction step to the xmlDoc.

Returns:
  the xmlNode containing the serialized step.

Reimplemented from gcu::Object.

bool gcp::ReactionStep::Load | ( | xmlNodePtr | node | ) | `[virtual]`

Parameters:

  | node,: | a pointer to the xmlNode containing the serialized step.

Used to load a reaction step in memory.

Returns:
  true on succes, false otherwise.

Reimplemented from gcu::Object.

double gcp::ReactionStep::GetYAlign | ( |  | ) | `[virtual]`

Used to retrieve the y coordinate for alignment.

Returns:
  y coordinate used for the reaction step alignment.

Reimplemented from gcu::Object.

bool gcp::ReactionStep::OnSignal | ( | gcu::SignalId | Signal,
|  | gcu::Object * | Child |
| ) |  |  | `[virtual]`

Parameters:

  | Signal | the appropriate SignalId
  | Child | the child which emitted the signal or NULL

This function is called by the framework when a signal has been emitted for the reaction step, when one of its children changed. It should not be called by a program; call Object::EmitSignal instead.

Returns:
  true if the signal should be propagated to the parent, false otherwise.

Reimplemented from gcu::Object.

void gcp::ReactionStep::AddArrow | ( | ReactionArrow * | arrow | ) | `[inline]`

Parameters:

  | arrow | an arrow related to this instance.

Adds an arrow to the list of arrows related to this instance.

Definition at line 114 of file reaction-step.h.

void gcp::ReactionStep::RemoveArrow | ( | ReactionArrow * | arrow | ) |

Parameters:

  | arrow | an arrow related to this instance.

Removes an arrow from the list of arrows related to this instance when it not anymore relevant.

The documentation for this class was generated from the following file:

- reaction-step.h